local conf = require("ssso_config")
local log = require("ssso_log")

local function read_user(user, password)
  local safe_u = user:gsub('"', '\\"'):gsub("[\r\n]", "")
  local safe_p = password:gsub('"', '\\"'):gsub("[\r\n]", "")
  local auth = (conf.get_auth_commands()).check
  auth = auth:gsub("\ru%.", safe_u)
  auth = auth:gsub("\rp%.", safe_p)
  log.debug("Running auth command: " .. auth)
  local out = io.popen(auth, "r")
  if not out then
    return nil
  end
  local name = out:read()
  if not name or name == "" then
    out:close()
    return nil
  end
  local email = out:read()
  out:close()
  if not email or email == "" then
    return nil
  end
  return {
    name = name,
    email = email,
  }
end

local function change_password(user, oldpwd, newpwd)
  -- TODO
  return "TODO"
end

return {
  change_password = change_password, -- TODO: test
  read_user = read_user,
}
