local lu = require("luaunit")
local ngx = require("ngx")

require("do_init")

function test_anonymous_access_to_private_page_of_mixed_site_sent_to_login_401()
  -- given
  ngx.req.reset()
  ngx.reset_var()
  ngx.var.request_uri = "/mixed/bob/wiki/_new"
  -- when
  local resp = require("do_access")
  -- then
  lu.assertEquals(resp, "307:https://my-domain.tld/ssso/login?back=/mixed/bob/wiki/_new&cause=401")
  lu.assertNil(ngx.req.header["Cookie"])
end

os.exit(lu.LuaUnit.run())
