local lu = require("luaunit")
local ngx = require("ngx")

require("do_init")

function test_anonymous_access_to_private_site_sent_to_login_401()
  -- given
  ngx.req.reset()
  ngx.reset_var()
  ngx.var.request_uri = "/private/page"
  -- when
  local resp = require("do_access")
  -- then
  lu.assertEquals(resp, "307:https://my-domain.tld/ssso/login?back=/private/page&cause=401")
  lu.assertNil(ngx.req.header["Authorization"])
end

os.exit(lu.LuaUnit.run())
