local lu = require("luaunit")
local auth = require("ssso_auth")
local conf = require("ssso_config")

local here = debug.getinfo(1).source:sub(2, -16)
conf.load_conf(here)

function test_read_user_with_good_credentials_returns_name_and_email()
  lu.assertEquals(auth.read_user("U", "goodpassword"), {
    name = "U",
    email = "U@example.org",
  })
end

function test_read_user_with_bad_credentials_returns_nil()
  lu.assertNil(auth.read_user("U", "badpassword"))
end

os.exit(lu.LuaUnit.run())
