local lu = require("luaunit")
local ngx = require("ngx")

require("do_init")

function test_login_url_returns_html_with_cause_displayed()
  -- given
  ngx.reset_resp_body()
  ngx.var.request_method = "GET"
  ngx.var.request_uri = "/ssso/login?back=/private/page&cause=403"
  local expected = [[<html><head>
  <link href="login.css">
  <script src="login.js"></script>
</head><body>
  <section id="messages"><p class="info">Different credentials might grant access to this resource.</p></section>
  <input value="/private/page">
</body></html>
]]
  -- when
  local resp = require("do_access")
  -- then
  lu.assertEquals(resp, 200)
  lu.assertEquals(ngx.say(), expected)
  lu.assertEquals(ngx.header["Content-Type"], "text/html; charset=UTF-8")
  lu.assertEquals(ngx.header["Content-Length"], tostring(#expected))
end

os.exit(lu.LuaUnit.run())
