local lu = require("luaunit")
local ngx = require("ngx")

require("do_init")

function test_login_css_url_returns_css()
  -- given
  ngx.reset_resp_body()
  ngx.var.request_method = "GET"
  ngx.var.request_uri = "/ssso/login.css"
  local expected = "/*CSS*/\n"
  -- when
  local resp = require("do_access")
  -- then
  lu.assertEquals(resp, 200)
  lu.assertEquals(ngx.header["Content-Type"], "text/css; charset=UTF-8")
  lu.assertEquals(ngx.header["Content-Length"], tostring(#expected))
  lu.assertEquals(ngx.say(), expected)
end

os.exit(lu.LuaUnit.run())
