local lu = require("luaunit")
local ngx = require("ngx")

require("do_init")

function test_login_js_url_returns_js()
  -- given
  ngx.reset_resp_body()
  ngx.var.request_method = "GET"
  ngx.var.request_uri = "/ssso/login.js"
  local expected = "//JS\n"
  -- when
  local resp = require("do_access")
  -- then
  lu.assertEquals(resp, 200)
  lu.assertEquals(ngx.header["Content-Type"], "application/javascript; charset=UTF-8")
  lu.assertEquals(ngx.header["Content-Length"], tostring(#expected))
  lu.assertEquals(ngx.say(), expected)
end

os.exit(lu.LuaUnit.run())
