local lu = require("luaunit")
local ngx = require("ngx")

require("do_init")

function test_unknown_login_url_returns_404()
  -- given
  ngx.reset_resp_body()
  ngx.var.request_method = "GET"
  ngx.var.request_uri = "/ssso/login.html"
  -- when
  local resp = require("do_access")
  -- then
  lu.assertEquals(resp, 404)
  lu.assertNil(ngx.header["Content-Type"])
  lu.assertNil(ngx.header["Content-Length"])
  lu.assertNil(ngx.say())
end

os.exit(lu.LuaUnit.run())
