local lu = require("luaunit")
local ngx = require("ngx")

require("do_init")

function test_successful_login_with_back_url_goes_to_url()
  -- given
  ngx.reset_var()
  ngx.reset_post_var()
  ngx.var.request_method = "POST"
  ngx.var.request_uri = "/ssso/login"
  ngx.post_var.login = "goodlogin"
  ngx.post_var.password = "goodpassword"
  ngx.post_var.back = "/private/page"
  -- when
  local resp = require("do_access")
  -- then
  lu.assertEquals(resp, "302:https://my-domain.tld/private/page")
  lu.assertNil(ngx.header["Set-Cookie"].link)
  lu.assertStrMatches(ngx.header["Set-Cookie"].v, "SSSO_TOKEN=[^%.]+%.[^%.]+%.[^%.]+; Path=/; Expires=1626550390; Secure")
end

os.exit(lu.LuaUnit.run())
