local lu = require("luaunit")
local ngx = require("ngx")

require("do_init")

function test_failed_login_returns_to_login_with_message()
  -- given
  ngx.reset_var()
  ngx.reset_post_var()
  ngx.var.request_method = "POST"
  ngx.var.request_uri = "/ssso/login"
  ngx.post_var.login = "goodlogin"
  ngx.post_var.password = "badpassword"
  ngx.post_var.back = "/private/page"
  local expected = [[<html><head>
  <link href="login.css">
  <script src="login.js"></script>
</head><body>
  <section id="messages"><p class="warning">These credentials were rejected.</p></section>
  <input value="/private/page">
</body></html>
]]
  -- when
  local resp = require("do_access")
  -- then
  lu.assertEquals(resp, 200)
  lu.assertEquals(ngx.say(), expected)
  lu.assertEquals(ngx.header["Content-Type"], "text/html; charset=UTF-8")
  lu.assertEquals(ngx.header["Content-Length"], tostring(#expected))
end

os.exit(lu.LuaUnit.run())
