local lu = require("luaunit")
local ngx = require("ngx")
local crypto = require("ssso_crypto")
local sites = require("ssso_sites")

require("do_init")

function test_portal_css_url_returns_css()
  -- given
  local profile = sites.class__profile:build_from_lists("U", "P", "N", "u@h")
  local jws, _ = crypto.get_jws_and_tslimit(profile)
  ngx.reset_resp_body()
  ngx.reset_var()
  ngx.var.cookie_SSSO_TOKEN = jws
  ngx.var.request_method = "GET"
  ngx.var.request_uri = "/ssso/portal.css"
  local expected = "/*CSS*/\n"
  -- when
  local resp = require("do_access")
  -- then
  lu.assertEquals(resp, 200)
  lu.assertEquals(ngx.header["Content-Type"], "text/css; charset=UTF-8")
  lu.assertEquals(ngx.header["Content-Length"], tostring(#expected))
  lu.assertEquals(ngx.say(), expected)
end

os.exit(lu.LuaUnit.run())
