local lu = require("luaunit")
local ngx = require("ngx")
local crypto = require("ssso_crypto")
local sites = require("ssso_sites")

require("do_init")

function test_unknown_portal_url_returns_404()
  -- given
  local profile = sites.class__profile:build_from_lists("U", "P", "N", "u@h")
  local jws, _ = crypto.get_jws_and_tslimit(profile)
  ngx.reset_resp_body()
  ngx.reset_var()
  ngx.var.cookie_SSSO_TOKEN = jws
  ngx.var.request_method = "GET"
  ngx.var.request_uri = "/ssso/portal.html"
  -- when
  local resp = require("do_access")
  -- then
  lu.assertEquals(resp, 404)
  lu.assertNil(ngx.say())
end

os.exit(lu.LuaUnit.run())
